﻿Imports System.Data.Entity
Imports HowDoI.DBInitializers.Domain

Namespace HowDoI.DBInitializers.DataAccess
	Public Class BlogContext
		Inherits DbContext
		Public Property Blogs() As DbSet(Of Blog)
		Public Property Posts() As DbSet(Of Post)
		Public Property Comments() As DbSet(Of Comment)
	End Class

	Public Class BlogContextInitializer
		Inherits Entity.DropCreateDatabaseIfModelChanges(Of BlogContext)

		Protected Overrides Sub Seed(ByVal context As BlogContext)
            Dim TempList As New List(Of Blog) _
                From {
             New Blog With {.BloggerName = "Julie", .Title = "My Code First Blog", .DateCreated = Date.Now, .Posts = New List(Of Post) _
                        From {
             New Post With {.Title = "ForeignKeyAttribute Annotation", .DateCreated = New Date(2011, 3, 15), .Content = "Mark navigation property with ForeignKey"},
             New Post With {.Title = "Working with the ChangeTracker", .DateCreated = Date.Now, .Content = "You can use db.Entry to get to state for a single entry or" & "db.ChangeTracker.Entries to work with all of the tracked entries."}}},
             New Blog With {.BloggerName = "Ingemaar", .Title = "My Life as a Blog", .DateCreated = Date.Now.AddDays(1)},
             New Blog With {.BloggerName = "Sampson", .Title = "Tweeting for Dogs", .DateCreated = Date.Now.AddDays(2)}}
            TempList.ForEach(Function(b) context.Blogs.Add(b))
			MyBase.Seed(context)
		End Sub
	End Class
End Namespace
